//Copyright Monogram (Grant & Union) 2021
#include "Actions/CameraPedestal.h"
#include "Engine/Selection.h"
#include "Camera/CameraActor.h"

void UCameraPedestal::Handle(FName Command, Operation Operation, float Value)
{
	if (!GEditor) return;
	USelection* selected = GEditor->GetSelectedActors();
	if (!selected) return;

	ACameraActor* topSelected = selected->GetTop<ACameraActor>();
	if (!topSelected) return;
	FVector smallDelta = topSelected->GetActorUpVector() * Value;
	this->PreAction(Cast<AActor>(topSelected));
	FProperty* PositionProperty = FindFieldChecked<FProperty>(USceneComponent::StaticClass(), "RelativeLocation");

	FEditPropertyChain changeChain;
	changeChain.AddHead(PositionProperty);//reverse the order here

	changeChain.SetActiveMemberPropertyNode(PositionProperty);
	Cast<UObject>(topSelected)->PreEditChange(changeChain);

	topSelected->AddActorWorldOffset(smallDelta);

	FPropertyChangedEvent changeEvent = FPropertyChangedEvent(PositionProperty);
	Cast<UObject>(topSelected)->PostEditChangeProperty(changeEvent);
	this->PostAction(Cast<AActor>(topSelected));
}
