//Copyright Monogram (Grant & Union) 2021
#include "Actions/CameraRail.h"
#include "Engine/Selection.h"
#include "Camera/CameraActor.h"
#include "CameraRig_Rail.h"

void UCameraRail::Handle(FName Command, Operation Operation, float Value)
{
	if (!GEditor) return;
	USelection* selected = GEditor->GetSelectedActors();
	if (!selected) return;

	ACameraRig_Rail* topSelected = selected->GetTop<ACameraRig_Rail>();
	if (!topSelected) return;

	this->PreAction(Cast<AActor>(topSelected));
	FProperty* RailPositionProperty = FindFieldChecked<FProperty>(ACameraRig_Rail::StaticClass(), "CurrentPositionOnRail");

	FEditPropertyChain changeChain;
	changeChain.AddHead(RailPositionProperty);//reverse the order here	

	changeChain.SetActiveMemberPropertyNode(RailPositionProperty);
	Cast<UObject>(topSelected)->PreEditChange(changeChain);

	if (Operation == Operation::SET) {
		topSelected->CurrentPositionOnRail = Value;
	}
	else if (Operation == Operation::ADJUST) {
		
		topSelected->CurrentPositionOnRail += Value;
	}

	FPropertyChangedEvent changeEvent = FPropertyChangedEvent(RailPositionProperty);
	Cast<UObject>(topSelected)->PostEditChangeProperty(changeEvent);
	this->PostAction(Cast<AActor>(topSelected));

}
