//Copyright Monogram (Grant & Union) 2021
#include "Actions/CineCameraToggleLookAt.h"
#include "Engine/Selection.h"
#include "CineCameraActor.h"
#include "CineCameraComponent.h"

void UCineCameraToggleLookAt::Handle(FName Command, Operation Operation, float Value)
{
	if (!GEditor) return;
	USelection* selected = GEditor->GetSelectedActors();
	if (!selected) return;

	ACineCameraActor* topSelected = selected->GetTop<ACineCameraActor>();
	if (!topSelected) return;

	this->PreAction(Cast<AActor>(topSelected));
	UCineCameraComponent* cineComponent = topSelected->GetCineCameraComponent();
	topSelected->LookatTrackingSettings.bEnableLookAtTracking = !topSelected->LookatTrackingSettings.bEnableLookAtTracking;
	this->PostAction(Cast<AActor>(topSelected));
}
