//Copyright Monogram (Grant & Union) 2021
#include "Actions/RotateCamera.h"
#include "Engine/Selection.h"
#include "Camera/CameraActor.h"

void URotateCamera::Handle(FName Command, Operation Operation, float Value)
{
	if (!GEditor) return;
	USelection* selected = GEditor->GetSelectedActors();
	if (!selected) return;

	ACameraActor* topSelected = selected->GetTop<ACameraActor>();
	if (!topSelected) return;

	FRotator smallDelta(0.0f, 0.0f, 0.0f);
	FRotator prevRotation = topSelected->GetActorRotation();
	if (Command == TEXT("Y"))
	{
		smallDelta.Pitch = Value;
		prevRotation.Pitch = Value;
	}
	else if (Command == TEXT("Z"))
	{
		smallDelta.Yaw = Value;
		prevRotation.Yaw = Value;
	}
	else if (Command == TEXT("X"))
	{
		smallDelta.Roll = Value;
		prevRotation.Roll = Value;
	}

	this->PreAction(Cast<AActor>(topSelected));
	if (Command == TEXT("X") || Command == TEXT("Y"))
	{
		if (Operation == Operation::ADJUST)
		{
			topSelected->AddActorLocalRotation(smallDelta);
		}
		else if (Operation == Operation::SET)
		{
			topSelected->SetActorRotation(prevRotation);
		}
	}
	else if (Command == TEXT("Z"))
	{
		if (Operation == Operation::ADJUST)
		{
			topSelected->AddActorWorldRotation(smallDelta);
		}
		else if (Operation == Operation::SET)
		{
			topSelected->SetActorRotation(prevRotation);
		}
	}
	else if (Command == TEXT("Reset"))
	{
		FRotator zero(0.0f);
		topSelected->SetActorRotation(zero);
	}
	this->PostAction(Cast<AActor>(topSelected));
}
