//Copyright Monogram (Grant & Union) 2021
#include "Actions/ScaleAll.h"
#include "Engine/Selection.h"

void UScaleAll::Handle(FName Command, Operation Operation, float Value)
{
	if (!GEditor) return;
	USelection* selected = GEditor->GetSelectedActors();
	if (!selected) return;

	AActor* topSelected = selected->GetTop<AActor>();
	if (!topSelected) return;

	this->PreAction(Cast<AActor>(topSelected));
	if (Operation == Operation::ADJUST)
	{
		topSelected->SetActorScale3D(topSelected->GetActorScale3D() * (1.0f + Value));
	}
	else if (Operation == Operation::SET)
	{
		FVector unitVector(1.0f);
		topSelected->SetActorScale3D(unitVector * Value);
	}
	this->PostAction(Cast<AActor>(topSelected));
}
