//Copyright Monogram (Grant & Union) 2021
#include "Actions/ScaleY.h"
#include "Engine/Selection.h"

void UScaleY::Handle(FName Command, Operation Operation, float Value)
{
	if (!GEditor) return;
	USelection* selected = GEditor->GetSelectedActors();
	if (!selected) return;

	AActor* topSelected = selected->GetTop<AActor>();
	if (!topSelected) return;

	this->PreAction(Cast<AActor>(topSelected));
	if (Operation == Operation::ADJUST)
	{
		topSelected->SetActorScale3D(FVector(topSelected->GetActorScale3D().X, topSelected->GetActorScale3D().Y * (1.0f + Value), topSelected->GetActorScale3D().Z));
	}
	else if (Operation == Operation::SET)
	{
		topSelected->SetActorScale3D(FVector(topSelected->GetActorScale3D().X, Value, topSelected->GetActorScale3D().Z));	
	}
	this->PostAction(Cast<AActor>(topSelected));
}
