//Copyright Monogram (Grant & Union) 2021
#include "Actions/ShuttleSequencer.h"
#include "Editor/Sequencer/Public/SequencerCommands.h"

void UShuttleSequencer::Handle(FName Command, Operation Operation, float Value)
{
	const FSequencerCommands& Commands = FSequencerCommands::Get();

	if (Value < 0)
	{
		this->GetSequencer()->GetCommandBindings()->ExecuteAction(Commands.StepBackward.ToSharedRef());
	}
	else
	{
		this->GetSequencer()->GetCommandBindings()->ExecuteAction(Commands.StepForward.ToSharedRef());
	}

	this->GetSequencer()->NotifyMovieSceneDataChanged(EMovieSceneDataChangeType::TrackValueChangedRefreshImmediately);
}
