//Copyright Monogram (Grant & Union) 2021
#include "Actions/SpotLightAttenuationRadius.h"
#include "Components/SpotLightComponent.h"
#include "Engine/Selection.h"
#include "Engine/SpotLight.h"

void USpotLightAttenuationRadius::Handle(FName Command, Operation Operation, float Value)
{
	if (!GEditor) return;
	USelection* selected = GEditor->GetSelectedActors();
	if (!selected) return;

	ASpotLight* topSelected = selected->GetTop<ASpotLight>();
	if (!topSelected) return;
	this->PreAction(Cast<AActor>(topSelected));
	
	if (Operation == Operation::ADJUST)
	{
		topSelected->SpotLightComponent->SetAttenuationRadius(topSelected->SpotLightComponent->AttenuationRadius + Value);
	}
	else if (Operation == Operation::SET)
	{
		topSelected->SpotLightComponent->SetAttenuationRadius(Value);
	}
	
	this->PostAction(Cast<AActor>(topSelected));
}
