//Copyright Monogram (Grant & Union) 2021
#include "Actions/SpotLightInnerConeAngle.h"
#include "Engine/Selection.h"
#include "Engine/SpotLight.h"
#include "Components/SpotLightComponent.h"

void USpotLightInnerConeAngle::Handle(FName Command, Operation Operation, float Value)
{
	if (!GEditor) return;
	USelection* selected = GEditor->GetSelectedActors();
	if (!selected) return;

	ASpotLight* topSelected = selected->GetTop<ASpotLight>();
	if (!topSelected) return;
	this->PreAction(Cast<AActor>(topSelected));

	if (Operation == Operation::ADJUST)
	{
		topSelected->SpotLightComponent->SetInnerConeAngle(topSelected->SpotLightComponent->InnerConeAngle + Value);
	}
	else if (Operation == Operation::SET)
	{
		topSelected->SpotLightComponent->SetInnerConeAngle(Value);
	}
	
	this->PostAction(Cast<AActor>(topSelected));
}
