//Copyright Monogram (Grant & Union) 2021
#include "Actions/SpotLightSourceRadius.h"
#include "Engine/Selection.h"

void USpotLightSourceRadius::Handle(FName Command, Operation Operation, float Value)
{
	if (!GEditor) return;
	USelection* selected = GEditor->GetSelectedActors();
	if (!selected) return;

	ASpotLight* topSelected = selected->GetTop<ASpotLight>();
	if (!topSelected) return;
	this->PreAction(Cast<AActor>(topSelected));

	if (Operation == Operation::ADJUST)
	{
		topSelected->SpotLightComponent->SetSourceRadius(topSelected->SpotLightComponent->SourceRadius + Value);
	}
	else if (Operation == Operation::SET)
	{
		topSelected->SpotLightComponent->SetSourceRadius(Value);
	}
	
	this->PostAction(Cast<AActor>(topSelected));
}
