//Copyright Monogram (Grant & Union) 2021
#include "Actions/ZoomSequencer.h"
#include "Editor/Sequencer/Public/SequencerCommands.h"

void UZoomSequencer::Handle(FName Command, Operation Operation, float Value)
{
	const FSequencerCommands& Commands = FSequencerCommands::Get();

	if (Value > 0)
	{
		this->GetSequencer()->GetCommandBindings()->ExecuteAction(Commands.ZoomInViewRange.ToSharedRef());
	}
	else if (Value < 0)
	{
		this->GetSequencer()->GetCommandBindings()->ExecuteAction(Commands.ZoomOutViewRange.ToSharedRef());
	}
	else
	{
		//zoomtofit was added in 4.26
#if (ENGINE_MAJOR_VERSION >= 4) && (ENGINE_MINOR_VERSION >= 26)
		this->GetSequencer()->GetCommandBindings()->ExecuteAction(Commands.ZoomToFit.ToSharedRef());
#endif
	}

	this->GetSequencer()->NotifyMovieSceneDataChanged(EMovieSceneDataChangeType::TrackValueChangedRefreshImmediately);
}
