//Copyright Monogram (Grant & Union) 2021

#pragma once

#include "Engine.h"
#include "HAL/RunnableThread.h"
#include "HAL/Runnable.h"
#include "CoreMinimal.h"
#include "Containers/UnrealString.h"
#include "Containers/Map.h"
#include "Subsystems/EngineSubsystem.h"

#include "TCPMonogramThread.h"
#include "MonogramEditorAction.h"

#include "MonogramEditorActions.generated.h"

class FMonogramEditorActionsModuleInterface : public IModuleInterface
{	/** IModuleInterface implementation */
	virtual void StartupModule() override;
	virtual void ShutdownModule() override;
};

UCLASS()
class MONOGRAMEDITORACTIONS_API UMonogramEditorActions : public UEngineSubsystem, public IModuleInterface
{
	GENERATED_BODY()
public:
	// Statically override this method to add the MonogramActions MultiMap to
	// the garbage collector.

	virtual void Initialize(FSubsystemCollectionBase& Collection) override;
	virtual void Deinitialize() override;
	
	UMonogramEditorActions();
	~UMonogramEditorActions();

	UFUNCTION(BlueprintCallable)
	static void PreChange(AActor *in);
	UFUNCTION(BlueprintCallable)
	static void PostChange(AActor *in);

};
