//Copyright Monogram (Grant & Union) 2021
#pragma once
#include "MonogramEditorActions.h"
#include "HAL/ThreadSafeBool.h"

class TransactionThread : public FRunnable
{
	virtual bool Init();
	virtual uint32 Run();
	virtual void Stop();
	FGenericPlatformProcess process;
};

class MonogramTransactionManager {
public:
	static MonogramTransactionManager* getAggrigator();
	void postAction(AActor* modifiedActor);
	void preAction(AActor* modifiedActor);
private:
	static MonogramTransactionManager* SingletonInstance;
	static FCriticalSection SingletonMutex;
	FThreadSafeBool openTransaction = false;
	FThreadSafeBool skipTransaction = true;
	friend class Monogram;
	friend class TransactionThread;
	MonogramTransactionManager();
	TransactionThread transThread;
	FRunnableThread* runningThread;
};

