//Copyright Monogram (Grant & Union) 2021
#pragma once

#include "Templates/SharedPointerInternals.h"
#include "Editor/Sequencer/Public/ISequencerModule.h"
#include "Editor/Sequencer/Public/ISequencer.h"

#include "MonogramEditorAction.h"

#include "SequencerAction.generated.h"

UCLASS(Abstract)
class USequencerAction : public UEditorAction {
	GENERATED_BODY()
public:
	USequencerAction();

	virtual FName Name() override { return TEXT(""); }
	virtual void Run(FName Command, Operation Operation, float Value) override;

	TSharedPtr<ISequencer> GetSequencer();
private:
	static void SetSequencer(TSharedPtr<ISequencer> SequencerPtr);

	static TWeakPtr<ISequencer> Sequencer;
	static FCriticalSection SequencerMutex;
	static FThreadSafeBool Initialized;
};